//*****************************************************************
// 
//  JAVA Source for com.idautomation.datamatrix; 2010
//  
//	 Copyright IDAutomation.com, Inc. All rights reserved.
//	Redistribution and use of this code in source and/or binary 
//	forms, with or without modification, are permitted provided 
//	that: (1) all copies of the source code retain the above 
//	unmodified copyright notice and this entire unmodified 
//	section of text, (2) You or Your organization owns a valid 
//	Developer License to this product from IDAutomation.com 
//	and, (3) when any portion of this code is bundled in any 
//	form with an application, a valid notice must be provided 
//	within the user documentation, start-up screen or in the 
//	help-about section of the application that specifies 
//	IDAutomation.com as the provider of the Software bundled 
//	with the application.
//*****************************************************************


package com.idautomation.datamatrix;

import java.awt.*;
import java.applet.*;

/** This is the DataMatrix applet that creates a barcode from the DataMatrix class. */

public class DataMatrixApplet extends Applet
{

        // ** updated for servlet operation 5/31/2001
	public DataMatrix BC=null;
        public boolean isStandalone=false;
        // ** end of update

	public DataMatrixApplet() 
        {
            this.setLayout(new java.awt.BorderLayout());
	}

	public void start() 
        {
            BC.paint(this.getGraphics());
            BC.autoSize=false;
	}

	public void refresh() 
        {
            BC.paint(BC.getGraphics());
            this.paintAll(this.getGraphics());
	}

	public void init() 
        {
            // create bar code DataMatrix
            if (BC==null) BC=new DataMatrix();	

            this.add("Center",BC);		

            initParam("N");
            initParam("X");
            initParam("I");
            initParam("H");
            initParam("BAR_COLOR");
            initParam("BC");
            initParam("BACK_COLOR");
            initParam("BGC");
            initParam("BARCODE");
            initParam("D");
            initParam("ROTATE");
            initParam("O");
            initParam("IR");
            initParam("LM");
            initParam("TM");

            // DataMatrix specific
            initParam("MARGIN");
            initParam("PFMT");
            initParam("PT");
            initParam("MODE");
	}

	private void initParam(String p) 
        {
            String v=getStringParam(p,"");
            if (v.length()==0) return;
	    setParameter(p,v);
	}

	public void setParameter(String p,String v) 
        {

            if (v==null) return;
		
		if (p.compareTo("ROTATE")==0) BC.rotate=(int) (new Double(v).doubleValue());
		
		if (p.compareTo("X")==0) BC.setXDimensionCM((double) (new Double(v).doubleValue()));

		if (p.compareTo("MARGIN")==0) BC.marginCM=new Double(v).doubleValue();

		//if (p.compareTo("I")==0) BC.I=new Double(v).doubleValue();

		if (p.compareTo("BAR_COLOR")==0) BC.barColor=convertColor(v);

		if (p.compareTo("BACK_COLOR")==0) BC.backColor=convertColor(v);

		if (p.compareTo("BARCODE")==0) BC.setDataToEncode(v);
            
                if (p.compareTo("D")==0) BC.setDataToEncode(v);
            
                if (p.compareTo("BC")==0) BC.barColor=convertColor(v);

		if (p.compareTo("BGC")==0) BC.backColor=convertColor(v);
            
                if (p.compareTo("ROTATE")==0) BC.rotate=(int) (new Double(v).doubleValue());
            
                if (p.compareTo("LM")==0) BC.leftMarginCM=new Double(v).doubleValue();
            
                if (p.compareTo("TM")==0) BC.topMarginCM=new Double(v).doubleValue();
            
                if (p.compareTo("IR")==0) BC.setPixelsPerCM(new Integer(v).intValue());
            
                if (p.compareTo("O")==0) BC.rotate=(int) (new Double(v).doubleValue());

                // data matrix
                // if (p.compareTo("DM_DOT_PIXELS")==0) BC.dotPixels=new Integer(v).intValue();
                //if (p.compareTo("DM_MARGIN_PIXELS")==0) BC.margin=new Integer(v).intValue();
                if (p.compareTo("PT")==0)
                {
                    String PTParameter = v;
                    if(PTParameter.toUpperCase().compareTo("Y") == 0 || PTParameter.toUpperCase().compareTo("YES") == 0 ||
                       PTParameter.toUpperCase().compareTo("TRUE") == 0 || PTParameter.toUpperCase().compareTo("T") == 0)
                        BC.processTilde = true;
                    else
                        BC.processTilde = false;

                }    
                if (p.compareTo("MODE")==0) 
                {
                    if (v.toUpperCase().compareTo("ASCII")==0 || v.compareTo("0") == 0) BC.encoding=BC.E_ASCII;
                    if (v.toUpperCase().compareTo("C40")==0 || v.compareTo("1") == 0) BC.encoding=BC.E_C40;
                    if (v.toUpperCase().compareTo("TEXT")==0 || v.compareTo("2") == 0) BC.encoding=BC.E_TEXT;
                    if (v.toUpperCase().compareTo("BASE256")==0 || v.compareTo("3") == 0) BC.encoding=BC.E_BASE256;
                    if (v.toUpperCase().compareTo("AUTO")==0 || v.compareTo("4") == 0) BC.encoding=BC.E_BASE256;
                }

                if (p.compareTo("PFMT")==0) 
                {
                    BC.preferredFormat=-1; // default, auto
                    if (v.toUpperCase().compareTo("C10X10")==0 || v.compareTo("1") == 0) BC.preferredFormat=BC.C10X10;
                    if (v.toUpperCase().compareTo("C12X12")==0 || v.compareTo("2") == 0) BC.preferredFormat=BC.C12X12;
                    if (v.toUpperCase().compareTo("C14X14")==0 || v.compareTo("3") == 0) BC.preferredFormat=BC.C14X14;
                    if (v.toUpperCase().compareTo("C16X16")==0 || v.compareTo("4") == 0) BC.preferredFormat=BC.C16X16;
                    if (v.toUpperCase().compareTo("C18X18")==0 || v.compareTo("5") == 0) BC.preferredFormat=BC.C18X18;
                    if (v.toUpperCase().compareTo("C20X20")==0 || v.compareTo("6") == 0) BC.preferredFormat=BC.C20X20;
                    if (v.toUpperCase().compareTo("C22X22")==0 || v.compareTo("7") == 0) BC.preferredFormat=BC.C22X22;
                    if (v.toUpperCase().compareTo("C24X24")==0 || v.compareTo("8") == 0) BC.preferredFormat=BC.C24X24;
                    if (v.toUpperCase().compareTo("C26X26")==0 || v.compareTo("9") == 0) BC.preferredFormat=BC.C26X26;
                    if (v.toUpperCase().compareTo("C32X32")==0 || v.compareTo("10") == 0) BC.preferredFormat=BC.C32X32;
                    if (v.toUpperCase().compareTo("C36X36")==0 || v.compareTo("11") == 0) BC.preferredFormat=BC.C36X36;
                    if (v.toUpperCase().compareTo("C40X40")==0 || v.compareTo("12") == 0) BC.preferredFormat=BC.C40X40;
                    if (v.toUpperCase().compareTo("C44X44")==0 || v.compareTo("13") == 0) BC.preferredFormat=BC.C44X44;
                    if (v.toUpperCase().compareTo("C48X48")==0 || v.compareTo("14") == 0) BC.preferredFormat=BC.C48X48;
                    if (v.toUpperCase().compareTo("C52X52")==0 || v.compareTo("15") == 0) BC.preferredFormat=BC.C52X52;
                    if (v.toUpperCase().compareTo("C64X64")==0 || v.compareTo("16") == 0) BC.preferredFormat=BC.C64X64;
                    if (v.toUpperCase().compareTo("C72X72")==0 || v.compareTo("17") == 0) BC.preferredFormat=BC.C72X72;
                    if (v.toUpperCase().compareTo("C80X80")==0 || v.compareTo("18") == 0) BC.preferredFormat=BC.C80X80;
                    if (v.toUpperCase().compareTo("C88X88")==0 || v.compareTo("19") == 0) BC.preferredFormat=BC.C88X88;
                    if (v.toUpperCase().compareTo("C96X96")==0 || v.compareTo("20") == 0) BC.preferredFormat=BC.C96X96;
                    if (v.toUpperCase().compareTo("C104X104")==0 || v.compareTo("21") == 0)	BC.preferredFormat=BC.C104X104;
                    if (v.toUpperCase().compareTo("C120X120")==0 || v.compareTo("22") == 0)	BC.preferredFormat=BC.C120X120;
                    if (v.toUpperCase().compareTo("C132X132")==0 || v.compareTo("23") == 0)	BC.preferredFormat=BC.C132X132;
                    if (v.toUpperCase().compareTo("C144X144")==0 || v.compareTo("24") == 0)	BC.preferredFormat=BC.C144X144;
                    if (v.toUpperCase().compareTo("C8X18")==0 || v.compareTo("25") == 0)		BC.preferredFormat=BC.C8X18;
                    if (v.toUpperCase().compareTo("C8X32")==0 || v.compareTo("26") == 0)		BC.preferredFormat=BC.C8X32;
                    if (v.toUpperCase().compareTo("C12X26")==0 || v.compareTo("27") == 0)	BC.preferredFormat=BC.C12X26;
                    if (v.toUpperCase().compareTo("C12X36")==0 || v.compareTo("28") == 0)	BC.preferredFormat=BC.C12X36;
                    if (v.toUpperCase().compareTo("C16X36")==0 || v.compareTo("29") == 0)	BC.preferredFormat=BC.C16X36;
                    if (v.toUpperCase().compareTo("C16X48")==0 || v.compareTo("30") == 0)	BC.preferredFormat=BC.C16X48;
                }
	}

    // function to convert a String parameter to a color
    public java.awt.Color convertColor(String c) 
    {
        if (c.toUpperCase().compareTo("NULL")==0) return null;
        if (c.toUpperCase().compareTo("RED")==0) return java.awt.Color.red;
        if (c.toUpperCase().compareTo("BLACK")==0) return java.awt.Color.black;
        if (c.toUpperCase().compareTo("BLUE")==0) return java.awt.Color.blue;
        if (c.toUpperCase().compareTo("CYAN")==0) return java.awt.Color.cyan;
        if (c.toUpperCase().compareTo("DARKGRAY")==0) return java.awt.Color.darkGray;
        if (c.toUpperCase().compareTo("GRAY")==0) return java.awt.Color.gray;
        if (c.toUpperCase().compareTo("GREEN")==0) return java.awt.Color.green;
        if (c.toUpperCase().compareTo("LIGHTGRAY")==0) return java.awt.Color.lightGray;
        if (c.toUpperCase().compareTo("MAGENTA")==0) return java.awt.Color.magenta;
        if (c.toUpperCase().compareTo("ORANGE")==0) return java.awt.Color.orange;
        if (c.toUpperCase().compareTo("PINK")==0) return java.awt.Color.pink;
        if (c.toUpperCase().compareTo("WHITE")==0) return java.awt.Color.white;
        if (c.toUpperCase().compareTo("YELLOW")==0) return java.awt.Color.yellow;
        try 
        {
            return java.awt.Color.decode(c);
        } 
        catch (Exception e) 
        {
            return java.awt.Color.black;
        }
    }

  // convert an applet parameter to a Font
  public java.awt.Font convertFont(String f) {

    String[] items=convertList(f);

   if (items==null) return null;

    if (items.length<3) return null;

    int s=java.awt.Font.PLAIN;
    if (items[1].compareTo("BOLD")==0) s=java.awt.Font.BOLD;
    if (items[1].compareTo("ITALIC")==0) s=java.awt.Font.ITALIC;

    try {
    return new java.awt.Font(items[0],s,new Integer(items[2]).intValue());
    }
    catch (Exception e) {return null;}

  }

  // ** updated for servlet operation 5/31/2001
  // get a parameter as string
  protected String getStringParam(String Param,String def) {

      return this.getParameter(Param, def);


    }


  //Get a parameter value
  private String getParameter(String key, String def) {


    if (isStandalone) return def;

    if (this.getParameter(key) != null) return this.getParameter(key) ;
    else return def;
  }

  private String[] convertList(String items){

   String[] itema=new String[500];
   int itemCount=0;

   // count number of items
   int p=items.indexOf("|");
   while (p>=0) {
      itema[itemCount++]=items.substring(0,p);
      items=items.substring(p+1,items.length());
      p=items.indexOf("|");
   }

   if (items.compareTo("")!=0) itema[itemCount++]=items;

   if (itemCount==0) return null;

   String[] result=new String[itemCount];
   for (int i=0;i<itemCount;i++) result[i]=itema[i];

   return result;

 }

  private Integer getIntParam(String Param,Integer def) {

    try {
      String s=this.getParameter(Param ,"");
      if (s.compareTo("")==0) return def;
      return new Integer(s);
    }
    catch(Exception e) {
      return def;
    }
   }

   private Double getDoubleParam(String Param,Double def) {

      try {
       String s=this.getParameter(Param ,"");
      if (s.compareTo("")==0) return def;
     return new Double(s);
    }
    catch(Exception e) {
      return def;
    }
    }
    // ** end of update

}
