//*****************************************************************
// 
//  JAVA Source for com.idautomation.datamatrix; 2010
//  
//	 Copyright IDAutomation.com, Inc. All rights reserved.
//	Redistribution and use of this code in source and/or binary 
//	forms, with or without modification, are permitted provided 
//	that: (1) all copies of the source code retain the above 
//	unmodified copyright notice and this entire unmodified 
//	section of text, (2) You or Your organization owns a valid 
//	Developer License to this product from IDAutomation.com 
//	and, (3) when any portion of this code is bundled in any 
//	form with an application, a valid notice must be provided 
//	within the user documentation, start-up screen or in the 
//	help-about section of the application that specifies 
//	IDAutomation.com as the provider of the Software bundled 
//	with the application.
//*****************************************************************

package com.idautomation.datamatrix;

import javax.servlet.*;
import javax.servlet.http.*;
import java.io.*;
import java.awt.Graphics2D.*;
import java.awt.*;
/** This is the DataMatrix servlet that creates a barcode from the DataMatrix class. */
public class IDAutomationServlet extends HttpServlet
{
    private boolean debug=false;
    public void init() throws ServletException  {  }

    // MODIFY THIS FUNCTION TO CREATE THE DataMatrix USING THE request PARAMETERS
    private DataMatrix getChart (HttpServletRequest request) 
    {
        DataMatrix cb=new DataMatrix();
        if (request!=null) 
        {
            // You may remark these parameters out if you do not need them.
            String st = null;
            if (request.getParameter("PFMT")!=null) 
            {
                st = (request.getParameter("PFMT"));
                if (st.toUpperCase().compareTo("C10X10")==0 || st.compareTo("1") == 0) cb.preferredFormat=cb.C10X10;
                if (st.toUpperCase().compareTo("C12X12")==0 || st.compareTo("2") == 0) cb.preferredFormat=cb.C12X12;
                if (st.toUpperCase().compareTo("C14X14")==0 || st.compareTo("3") == 0) cb.preferredFormat=cb.C14X14;
                if (st.toUpperCase().compareTo("C16X16")==0 || st.compareTo("4") == 0) cb.preferredFormat=cb.C16X16;
                if (st.toUpperCase().compareTo("C18X18")==0 || st.compareTo("5") == 0) cb.preferredFormat=cb.C18X18;
                if (st.toUpperCase().compareTo("C20X20")==0 || st.compareTo("6") == 0) cb.preferredFormat=cb.C20X20;
                if (st.toUpperCase().compareTo("C22X22")==0 || st.compareTo("7") == 0) cb.preferredFormat=cb.C22X22;
                if (st.toUpperCase().compareTo("C24X24")==0 || st.compareTo("8") == 0) cb.preferredFormat=cb.C24X24;
                if (st.toUpperCase().compareTo("C26X26")==0 || st.compareTo("9") == 0) cb.preferredFormat=cb.C26X26;
                if (st.toUpperCase().compareTo("C32X32")==0 || st.compareTo("10") == 0) cb.preferredFormat=cb.C32X32;
                if (st.toUpperCase().compareTo("C36X36")==0 || st.compareTo("11") == 0) cb.preferredFormat=cb.C36X36;
                if (st.toUpperCase().compareTo("C40X40")==0 || st.compareTo("12") == 0) cb.preferredFormat=cb.C40X40;
                if (st.toUpperCase().compareTo("C44X44")==0 || st.compareTo("13") == 0) cb.preferredFormat=cb.C44X44;
                if (st.toUpperCase().compareTo("C48X48")==0 || st.compareTo("14") == 0) cb.preferredFormat=cb.C48X48;
                if (st.toUpperCase().compareTo("C52X52")==0 || st.compareTo("15") == 0) cb.preferredFormat=cb.C52X52;
                if (st.toUpperCase().compareTo("C64X64")==0 || st.compareTo("16") == 0) cb.preferredFormat=cb.C64X64;
                if (st.toUpperCase().compareTo("C72X72")==0 || st.compareTo("17") == 0) cb.preferredFormat=cb.C72X72;
                if (st.toUpperCase().compareTo("C80X80")==0 || st.compareTo("18") == 0) cb.preferredFormat=cb.C80X80;
                if (st.toUpperCase().compareTo("C88X88")==0 || st.compareTo("19") == 0) cb.preferredFormat=cb.C88X88;
                if (st.toUpperCase().compareTo("C96X96")==0 || st.compareTo("20") == 0) cb.preferredFormat=cb.C96X96;
                if (st.toUpperCase().compareTo("C104X104")==0 || st.compareTo("21") == 0)	cb.preferredFormat=cb.C104X104;
                if (st.toUpperCase().compareTo("C120X120")==0 || st.compareTo("22") == 0)	cb.preferredFormat=cb.C120X120;
                if (st.toUpperCase().compareTo("C132X132")==0 || st.compareTo("23") == 0)	cb.preferredFormat=cb.C132X132;
                if (st.toUpperCase().compareTo("C144X144")==0 || st.compareTo("24") == 0)	cb.preferredFormat=cb.C144X144;
                if (st.toUpperCase().compareTo("C8X18")==0 || st.compareTo("25") == 0)		cb.preferredFormat=cb.C8X18;
                if (st.toUpperCase().compareTo("C8X32")==0 || st.compareTo("26") == 0)		cb.preferredFormat=cb.C8X32;
                if (st.toUpperCase().compareTo("C12X26")==0 || st.compareTo("27") == 0)	cb.preferredFormat=cb.C12X26;
                if (st.toUpperCase().compareTo("C12X36")==0 || st.compareTo("28") == 0)	cb.preferredFormat=cb.C12X36;
                if (st.toUpperCase().compareTo("C16X36")==0 || st.compareTo("29") == 0)	cb.preferredFormat=cb.C16X36;
                if (st.toUpperCase().compareTo("C16X48")==0 || st.compareTo("30") == 0)	cb.preferredFormat=cb.C16X48;
            }
            if (request.getParameter("MODE")!=null) 
            {
                st = (request.getParameter("MODE"));
                if (st.toUpperCase().compareTo("ASCII") == 0|| st.compareTo("0") == 0)		cb.encoding=cb.E_ASCII;
                if (st.toUpperCase().compareTo("C40") == 0 || st.compareTo("1") == 0)		cb.encoding=cb.E_C40;
                if (st.toUpperCase().compareTo("TEXT") == 0|| st.compareTo("2") == 0)		cb.encoding=cb.E_TEXT;
                if (st.toUpperCase().compareTo("BASE256") == 0 || st.compareTo("3") == 0)       cb.encoding=cb.E_BASE256;
                if (st.toUpperCase().compareTo("AUTO") == 0 || st.compareTo("4") == 0)   	cb.encoding=cb.E_BASE256;
            }
            if (request.getParameter("BC")!=null) cb.setForeground(convertColor(request.getParameter("BC")));
            if (request.getParameter("BGC")!=null) cb.setBackground(convertColor(request.getParameter("BGC")));
            if (request.getParameter("IR")!=null) cb.setPixelsPerCM(new Integer(request.getParameter("IR")).intValue());
            if (request.getParameter("ROTATE")!=null) cb.rotate=new Integer(request.getParameter("ROTATE")).intValue();
            if (request.getParameter("O")!=null) cb.rotate=new Integer(request.getParameter("O")).intValue();
            if (request.getParameter("MARGIN")!=null) cb.marginCM=new Double(request.getParameter("MARGIN")).doubleValue();
            if (request.getParameter("LM")!=null) cb.setLeftMarginCM(new Double(request.getParameter("LM")).doubleValue());
            if (request.getParameter("TM")!=null) cb.setTopMarginCM(new Double(request.getParameter("TM")).doubleValue());
            if (request.getParameter("X")!=null) cb.X=new Double(request.getParameter("X")).doubleValue();
            if (request.getParameter("PT")!=null)
            {
                String PTParameter = request.getParameter("PT");
                if(PTParameter.toUpperCase().compareTo("Y") == 0 || PTParameter.toUpperCase().compareTo("YES") == 0 ||
                   PTParameter.toUpperCase().compareTo("TRUE") == 0 || PTParameter.toUpperCase().compareTo("T") == 0)
                    cb.processTilde = true;
                else
                    cb.processTilde = false;
                
            }
            if (request.getParameter("BARCODE")!=null)
            {
                cb.code=request.getParameter("BARCODE"); 
            }
            else if (request.getParameter("D")!=null) 
            {
                cb.code=request.getParameter("D"); 
            }
            else  
            {
                cb.code="NO DATA TO ENCODE";
            }
        }
        else  
        {
            cb.code="NO DATA TO ENCODE";
        }
        return cb;
    }

    public java.awt.Color convertColor(String c) 
    {
        if (c.toUpperCase().compareTo("NULL")==0) return null;
        if (c.toUpperCase().compareTo("RED")==0) return java.awt.Color.red;
        if (c.toUpperCase().compareTo("BLACK")==0) return java.awt.Color.black;
        if (c.toUpperCase().compareTo("BLUE")==0) return java.awt.Color.blue;
        if (c.toUpperCase().compareTo("CYAN")==0) return java.awt.Color.cyan;
        if (c.toUpperCase().compareTo("DARKGRAY")==0) return java.awt.Color.darkGray;
        if (c.toUpperCase().compareTo("GRAY")==0) return java.awt.Color.gray;
        if (c.toUpperCase().compareTo("GREEN")==0) return java.awt.Color.green;
        if (c.toUpperCase().compareTo("LIGHTGRAY")==0) return java.awt.Color.lightGray;
        if (c.toUpperCase().compareTo("MAGENTA")==0) return java.awt.Color.magenta;
        if (c.toUpperCase().compareTo("ORANGE")==0) return java.awt.Color.orange;
        if (c.toUpperCase().compareTo("PINK")==0) return java.awt.Color.pink;
        if (c.toUpperCase().compareTo("WHITE")==0) return java.awt.Color.white;
        if (c.toUpperCase().compareTo("YELLOW")==0) return java.awt.Color.yellow;
        try 
        {
            return java.awt.Color.decode(c);
        } 
        catch (Exception e) 
        {
            return java.awt.Color.black;
        }
    }
    // Handle a request
    // 1. create DataMatrix
    // 2. draw DataMatrix in a Buffered Image
    // 3. encode image as GIF or JPEG and send it to the browser
    public void doGet (HttpServletRequest request, HttpServletResponse response) throws ServletException, IOException
    {
        PrintWriter out;
        ServletOutputStream outb;
        //10/23/2009, TB, changing default to gif
        //String encode="jpeg";
        String encode="gif";
        if (request!=null) 
        {
            if (request.getParameter("FORMAT")!=null)  encode=request.getParameter("FORMAT").toLowerCase();
            if (request.getParameter("I")!=null)  encode=request.getParameter("I").toLowerCase();
            if (encode.compareTo("gif")!=0) encode="jpeg";
        }
        response.setContentType("image/"+encode);
        outb=response.getOutputStream();
        // avoid caching in browser
        response.setHeader ("Pragma", "no-cache");
        response.setHeader ("Cache-Control", "no-cache");
        response.setDateHeader ("Expires",0);
        try 
        { 
            // Create buffer
            //the default height and width if not specified.
            int w=80;
            int h=80;
            // get DataMatrix
            DataMatrix cb=getChart(request);
            if ((request!=null) && (request.getParameter("WIDTH")!=null) && (request.getParameter("HEIGHT")!=null)) 
            {
                w=new Integer(request.getParameter("WIDTH")).intValue();
                h=new Integer(request.getParameter("HEIGHT")).intValue();
            }
            else if ((request!=null) && (request.getParameter("W")!=null) && (request.getParameter("H")!=null)) 
            {
                cb.autoSize = false;
                w=new Integer(request.getParameter("W")).intValue();
                h=new Integer(request.getParameter("H")).intValue();
            }
            else 
            {
                //a temp image must be created to find the preferred size
                cb.autoSize=true;
                cb.setSize(90,90);
                java.awt.image.BufferedImage imageTemp = new java.awt.image.BufferedImage( cb.getSize().width,cb.getSize().height,java.awt.image.BufferedImage.TYPE_BYTE_INDEXED );
                java.awt.Graphics imgTempGraphics = imageTemp.createGraphics();
                cb.paint(imgTempGraphics);
                cb.invalidate();
                w=cb.getSize().width;
                h=cb.getSize().height;
                imgTempGraphics.dispose();
            }

            java.awt.image.BufferedImage BarImage=new java.awt.image.BufferedImage(w,h,java.awt.image.BufferedImage.TYPE_INT_RGB);
            java.awt.Graphics2D BarGraphics=BarImage.createGraphics();
            cb.setSize(w,h);
            cb.paint(BarGraphics);
            if (encode.compareToIgnoreCase("gif")==0) 
            {
                // encode buffered image to a gif
                com.idautomation.datamatrix.encoder.GifEncoder encoder = new com.idautomation.datamatrix.encoder.GifEncoder(BarImage  ,outb);
                encoder.encode();
            }
            else
            {
                // create JPEG image
                com.sun.image.codec.jpeg.JPEGImageEncoder encoder = com.sun.image.codec.jpeg.JPEGCodec.createJPEGEncoder(outb );
                //increase the JPEG quality to 100%
                com.sun.image.codec.jpeg.JPEGEncodeParam param = encoder.getDefaultJPEGEncodeParam( BarImage); 
                param.setQuality(1.0F,true);
                encoder.setJPEGEncodeParam(param);
                encoder.encode( BarImage,param  );
            }
        } 
        catch (Exception e) 
        {
            e.printStackTrace();
        }
    }

    public void doPost (HttpServletRequest request,	HttpServletResponse response) throws ServletException
    {
        try 
        {
            doGet(request,response);
        } 
        catch (Exception e) 
        {
            e.printStackTrace();
        }
    }
}

